﻿using System;
using System.Data;
using System.Windows.Forms;
using Infragistics.Documents.Excel;

namespace UltraGridExcelExporter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            //ultraGridExcelExporter1.Export(ultraGrid1, "exportedGrid.xlsx", WorkbookFormat.Excel2007);
            ultraGridExcelExporter1.ExportAsync(ultraGrid1, "exportedGridAsync", WorkbookFormat.Excel2007);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.ExportEnded += new Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndedEventHandler(ultraGridExcelExporter1_ExportEnded);
            ultraGrid1.DataSource = GetData();
        }

        private void ultraGridExcelExporter1_ExportEnded(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndedEventArgs e)
        {
            MessageBox.Show("Export ended.");
        }

        private DataTable GetData(int rows = 65000)
        {
            DataTable table = new DataTable("Table1");

            table.Columns.Add("Boolean column", typeof(bool));
            table.Columns.Add("Integer column", typeof(int));
            table.Columns.Add("DateTime column", typeof(DateTime));
            table.Columns.Add("String column", typeof(string));

            for (int i = 0; i < rows; i++)
            {
                DataRow row = table.NewRow();
                row["Boolean column"] = i % 2 == 0 ? true : false;
                row["Integer column"] = i;
                row["String column"] = "text";
                row["DateTime column"] = DateTime.Today.AddDays(i);
                table.Rows.Add(row);
            }

            return table;
        }
    }
}
